<?php

if(basename($_SERVER['SCRIPT_FILENAME'])==basename(__FILE__))
    exit;
require_once(dirname(__FILE__).'/classws.php');

/**
 * @pw_complex stringArray A string array type
 */

class adminbcmServer
{
    private static $instance = null;
    private static $helper = null;

    public function __construct()
    {
        if(self::$instance===null)
        {
            self::$instance=$this;
            self::$helper=new adminbcmWSServer();
        }
    }
    public function __destruct()
    {
        if(self::$instance===$this)
        {
            self::$helper=null;
            self::$instance=null;
        }
    }
    public static function getInstance()
    {
        return self::$instance;
    }
    public static function getHelper()
    {
        return self::$helper;
    }

    public function login($user,$pass)
    {
        return self::$helper->login($user,$pass);
    }
    /**
     * Obtener el codigo del usuario logueado
     *
     * @return int Codigo
     */
    public function getUser()
    {
        return self::$helper->getUser();
    }
    /**
     * Obtener datos plan cliente
     *
     * @param string $ip ip del usuario
     * @return string json de datos
     */
    public function datosClientePlan($ip)
    {
        return self::$helper->datosClientePlan($ip);
    }
    /**
     * Dar de alta un nuevo cliente
     *
     * @param string $codCliente Codigo unico que identifica al cliente
     * @param stringArray $indices Array de nombres de los datos del plan a cargar
     * @param stringArray $datos Array de datos del plan a cargar
     * @return int codigo de Error
     */
    public function clienteAlta($codCliente,$indices,$datos)
    {
        return self::$helper->clienteAlta($codCliente,$indices,$datos);
    }
    /**
     * Dar de alta un nuevo cliente
     *
     * @param string $codCliente Codigo unico que identifica al cliente
     * @param stringArray $indices Array de nombres de los datos del plan a cargar
     * @param stringArray $datos Array de datos del plan a cargar
     * @return int codigo de Error
     */
    public function clienteMod($codCliente,$indices,$datos)
    {
        return self::$helper->clienteMod($codCliente,$indices,$datos);
    }
    /**
     * Bloquear o Desbloquear un cliente
     *
     * @param string $codCliente Id del cliente a modificar
     * @param boolean $bloquear Bloquear o desbloquear el cliente
     * @return int Response
     */
    public function clienteActualizarBloqueo($codCliente,$bloquear)
    {
        return self::$helper->clienteActualizarBloqueo($codCliente,$bloquear);
    }
    /**
     * Dar de alta una nueva orden de trabajo
     *
     * @param string $codCliente Codigo unico que identifica al cliente
     * @param stringArray $indices Array de nombres de los datos de la orden de trabajo
     * @param stringArray $datos Array de datos de la orden de trabajo
     * @return int codigo de Error
     */
    public function generarOT($codCliente,$indices,$datos)
    {
        return self::$helper->generarOT($codCliente,$indices,$datos);
    }
    /**
     * Dar de alta un nuevo plan de un cliente
     *
     * @param string $codCliente Id del cliente a modificar
     * @param string $codClientePlan Codigo unico que identifica al plan del cliente
     * @param stringArray $indices Array de nombres de los datos del plan a cargar
     * @param stringArray $datos Array de datos del plan a cargar
     * @return int codigo de Error
     */
    public function planAlta($codCliente,$codClientePlan,$indices,$datos)
    {
        return self::$helper->planAlta($codCliente,$codClientePlan,$indices,$datos);
    }
    /**
     * Modificar un plan de un  cliente
     *
     * @param string $codClientePlan Codigo unico que identifica al plan del cliente
     * @param stringArray $datos Array de datos del plan a cargar
     * @return int codigo de Error
     */
    public function planMod($codClientePlan,$datos)
    {
        return self::$helper->planMod($codClientePlan,$datos);
    }
    /**
     * Eliminar un plan de un  cliente
     *
     * @param string $codClientePlan Codigo unico que identifica al plan del cliente
     * @return int codigo de Error
     */
    public function planBaja($codClientePlan)
    {
        return self::$helper->planBaja($codClientePlan);
    }
    /**
     * Bloquear o Desbloquear un cliente
     *
     * @param string $codClientePlan Codigo unico del plan a modificar
     * @param boolean $bloquear Bloquear o desbloquear el cliente
     * @return int Response
     */
    public function planActualizarBloqueo($codClientePlan,$bloquear)
    {
        return self::$helper->planActualizarBloqueo($codClientePlan,$bloquear);
    }
}
